"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.launchPlopByConfig = exports.createAddManyTemplatesAction = exports.createAddConfigAction = exports.getTemplatePathByName = exports.getTemplatePath = exports.getLibPath = exports.getSourcePath = exports.getBasePath = void 0;
const path = __importStar(require("path"));
const run_command_1 = require("@attachments/utils/lib/node/run-command");
const getBasePath = () => path.resolve(__dirname, '..');
exports.getBasePath = getBasePath;
const getSourcePath = () => path.resolve(exports.getBasePath(), 'src');
exports.getSourcePath = getSourcePath;
const getLibPath = () => path.resolve(exports.getBasePath(), 'lib');
exports.getLibPath = getLibPath;
const getTemplatePath = () => path.resolve(exports.getSourcePath(), 'templates');
exports.getTemplatePath = getTemplatePath;
const getTemplatePathByName = (name) => path.resolve(exports.getTemplatePath(), name);
exports.getTemplatePathByName = getTemplatePathByName;
const createAddConfigAction = (name, p) => {
    return {
        type: 'add',
        path: p,
        templateFile: path.resolve(exports.getTemplatePath(), 'common', name),
    };
};
exports.createAddConfigAction = createAddConfigAction;
const createAddManyTemplatesAction = (name, destination) => {
    const tsTemplatePath = exports.getTemplatePathByName(name);
    return {
        type: 'addMany',
        destination,
        templateFiles: `${tsTemplatePath}/**/*`,
        base: tsTemplatePath,
    };
};
exports.createAddManyTemplatesAction = createAddManyTemplatesAction;
const launchPlopByConfig = async (generator) => {
    const configPath = path.resolve(exports.getLibPath(), 'configurations', 'node-plop', `${generator}.js`);
    const plopPath = path.resolve(require.resolve('plop'), '../../bin/plop.js');
    await run_command_1.runCommand('node', [plopPath, '--plopfile', configPath]);
};
exports.launchPlopByConfig = launchPlopByConfig;
//# sourceMappingURL=utils.js.map